///bs:-input,console
#include<bits\stdc++.h>
#include "testlib.h"
#define _ << ' ' <<

using namespace std;

const int MAXN = 1500, INF = 1e9, CNT_DIR = 8;

int c[MAXN][MAXN];

int xm, ym, xa, ya;

int n, m;

int dst(int x1, int y1, int x2, int y2) {
	int dx = x1 - x2, dy = y1 - y2;
	return dx * dx + dy * dy;
}

int getDirection(int x, int y) {
	int dx = xm - x, dy = ym - y;
	if (abs(dx) == abs(dy)) {
		if (dx < 0 && dy > 0) return 1;
		if (dx > 0 && dy > 0) return 3;
		if (dx > 0 && dy < 0) return 5;
		return 7;
	}
	if (abs(dy) > abs(dx)) {
		if (dy > 0) return 2;
		return 6;
	}
	if (dx > 0) return 4;
	return 0;
}

int revDir(int d) {
	return (d + CNT_DIR / 2) % CNT_DIR;
}

bool check() {
	vector<pair<int, int> > rev;
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			if (x == xm && y == ym) continue;
			int d = getDirection(x, y);
			if (d != c[x][y]) {
				if (d != revDir(c[x][y])) return 0;
				rev.push_back({x, y});
			}
		}
	}
	for (xa = 0; xa < n; xa++) {
		bool fl = 1;
		ya = -1;
		for (auto [x, y] : rev) {
			if (x == xa) continue;
			if (ya == -1) ya = y;
			if (ya != y) fl = 0;
		}
		if (fl) {
			if (ya == -1) ya = ym;
			return 1;
		}
	}
	return 0;
}

void out() {
	cout << xm + 1 << ' ' << ym + 1 << endl;
	cout << xa + 1 << ' ' << ya + 1 << endl;	
	exit(0);
}

bool slowSolution() {
	for (xm = 0; xm < n; xm++) {
		for (ym = 0; ym < m; ym++) {
			if (check()) {
				return 1;
			}
		}
	}
	return 0;
}

int cntRightDiag[MAXN * 2], cntLeftDiag[MAXN * 2];

pair<int, int> crossDiag(int iLeftDiag, int iRightDiag) {
	int j2 = iLeftDiag + iRightDiag - n + 1;
	if (j2 % 2 == 1) return {-1, -1};
	int j = j2 / 2;
	int i = iRightDiag - j;
	return {i, j};
}

bool fastSolution() {
	//checks angles of table
	for (xm = 0; xm < 2; xm++) {
		for (ym = 0; ym < 2; ym++) {
			if (xm == 1 && ym == 1) continue;
			if (check()) {
				return 1;
			}
		}
	}

	for (xm = 0; xm < 2; xm++) {
		for (ym = m - 2; ym < m; ym++) {
			if (xm == 1 && ym == m - 2) continue;
			if (check()) {
				return 1;
			}
		}
	}

	for (xm = n - 2; xm < n; xm++) {
		for (ym = 0; ym < 2; ym++) {
			if (xm == n - 2 && ym == 1) continue;
			if (check()) {
				return 1;
			}
		}
	}

	for (xm = n - 2; xm < n; xm++) {
		for (ym = m - 2; ym < m; ym++) {
			if (xm == n - 2 && ym == m - 2) continue;
			if (check()) {
				return 1;
			}
		}
	}

	vector<pair<int, int> > diag;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (c[i][j] % 2 == 1) {
				diag.push_back({i, j});
				int leftDiagIndex = j - i + n - 1;
				int rightDiagIndex = i + j;

				cntLeftDiag[leftDiagIndex]++;
				cntRightDiag[rightDiagIndex]++;
			}
		}
	}
	int iLeftMax = 0, iRightMax = 0;
	for (int i = 0; i < n + m - 1; i++) {
		if (cntLeftDiag[i] > cntLeftDiag[iLeftMax]) iLeftMax = i;
	}

	for (int i = 0; i < n + m - 1; i++) {
		if (cntRightDiag[i] > cntRightDiag[iRightMax]) iRightMax = i;
	}

	if (cntLeftDiag[iLeftMax] > 1 && cntRightDiag[iRightMax] > 1) {
		tie(xm, ym) = crossDiag(iLeftMax, iRightMax);
		if (check()) return 1;
		return 0;
	}
	return 0;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    n = inf.readInt(2, MAXN, "n");
    inf.readSpace();
    m = inf.readInt(2, MAXN, "m");
    ensuref(n * m >= 6, "nm lower than 6");
    inf.readEoln();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			c[i][j] = inf.readInt(1, 8, "a");
			if(j != m - 1)
			inf.readSpace();
			c[i][j]--;
		}
		inf.readEoln();
	}
	inf.readEof();
	
	if (n < 3 || m < 3) {
		ensuref(slowSolution(), "Not found correct answer");
		return 0;
	}

	ensuref(fastSolution(), "Not found correct answer");

	return 0;
}
