#include <bits/stdc++.h>

using namespace std;

void fast_io() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
}

int c;

vector<vector<int>> g;
vector<int> col;
int last = 1;

void gen_tree(int v, int h) {
    if (h == 0) return;
    g[v].resize(2);
    g[v][0] = last++;
    g[v][1] = last++;
    gen_tree(g[v][0], h - 1);
    gen_tree(g[v][1], h - 1);
}

void gen_tree(int h) {
    g.resize((1 << (h + 1)) - 1);
    col.resize((1 << (h + 1)) - 1, -1);
    gen_tree(0, h);
}

void paint(int v, int c_i) {
    col[v] = c_i;
    if (g[v].empty()) return;
    paint(g[v][0], (c_i + 1) % c);
    paint(g[v][1], (c_i + c - 1) % c);
}

void paint(string& path, int c_i) {
    int v = 0;
    for (auto i : path) {
        if (i == 'L') {
            v = g[v][0];
        } else {
            v = g[v][1];
        }
    }
    paint(v, c_i);
}

int get_c(string& path) {
    int v = 0;
    for (auto i : path) {
        if (i == 'L') {
            v = g[v][0];
        } else {
            v = g[v][1];
        }
    }
    return col[v];
}

struct query {
    int t, c_i;
    string path;
    query() {}
    query(int t, int c_i, string path) : t(t), c_i(c_i), path(path) {}
};

signed main() {
    fast_io();
    int q, t, c_i;
    cin >> q >> c;
    vector<query> queries(q);
    string path;
    int max_h = 0;
    for (int i = 0; i < q; ++i) {
        cin >> t;
        if (t == 1) {
            cin >> c_i;
        }
        cin >> path;
        queries[i] = {t, c_i, path};
        max_h = max(max_h, (int)path.size());
    }
    gen_tree(max_h);
    for (int i = 0; i < q; ++i) {
        if (queries[i].t == 1) {
            paint(queries[i].path, queries[i].c_i);
        } else {
            cout << get_c(queries[i].path) << '\n';
        }
    }
    return 0;
}