//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int q, c;
  cin >> q >> c;
  struct node {
    pair<int, int> lastMod{-1, -1};
    int go[2]{-1, -1};
  };
  vector<node> tree(1);

  auto walk = [&](auto& s) {
    int v = 0;
    for (auto ch : s) {
      int i = (ch == 'L' ? 0 : 1);
      if (tree[v].go[i] < 0) {
        tree[v].go[i] = int(tree.size());
        tree.emplace_back();
      }
      auto[tt, cc] = tree[v].lastMod;
      if (tt > tree[tree[v].go[i]].lastMod.first) {
        tree[tree[v].go[i]].lastMod = make_pair(tt, i == 0 ? (cc + 1) % c : (cc + c - 1) % c);
      }
      v = tree[v].go[i];
    }
    return v;
  };

  for (int qi = 0; qi < q; ++qi) {
    int t; cin >> t;
    if (t == 1) {
      int x; cin >> x;
      string s; cin >> s;
      int ver = walk(s);
      tree[ver].lastMod = make_pair(qi, x);
    } else {
      string s; cin >> s;
      cout << tree[walk(s)].lastMod.second << '\n';
    }
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
