//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n; cin >> n;
  vector<ll> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  vector<ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }
  ll need = (pref[n] + 1) / 2;
  int ans = n;
  for (int l = 0; l < n; ++l) {
    int f = l;
    int t = n + 1;  
    while (f + 1 != t) {
      int m = (f + t) / 2;
      if (pref[m] - pref[l] >= need) {
        t = m;
      } else {
        f = m;
      }
    }
    if (t != n + 1) {
      smin(ans, t - l);
    }
  }

  auto go = [&](int len) {
    if (len == 1) return false;

    multiset<ll> vals;
    ll su = 0;
    for (int i = 0; i < len - 1; ++i) {
      vals.insert(a[i]);
      su += a[i];
    }
    for (int i = len - 1; i < n; ++i) {
      su += a[i];
      vals.insert(a[i]);
      if (su - *vals.begin() >= need) {
        return true;
      }
      vals.erase(vals.find(a[i - (len - 1)]));
      su -= a[i - (len - 1)];
    }
    return false;
  };

  if (go(ans)) {
    --ans;
  }
  cout << ans << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
