#include "testlib.h"

using namespace std;

typedef long long ll;
typedef pair<ll, ll> p_ll;

int n;
vector<p_ll> info;

#define all(c) c.begin(), c.end()

ll score(int i, int j, int k) {
    return
            info[i].first * info[j].second +
            info[j].first * info[k].second +
            info[k].first * info[i].second;
}

bool check3(int i, int j, int k) {
    return score(i, j, k) >= score(k, j, i);
}

void check(InStream &in) {
    auto perm = in.readInts(n, 1, n, "no");
    in.ensuref(set<int>(all(perm)).size() == n, "all numbers should be different");
    for (int &idx : perm) {
        idx--;
    }
    for (int i = 0; i + 2 < n; i++) {
        in.ensuref(check3(perm[i], perm[i + 1], perm[i + 2]), "triple number %d is not good", i + 1);
    }
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for (int i = 0; i < n; i++) {
        int a = inf.readInt(), b = inf.readInt();
        info.emplace_back(a, b);
    }

    check(ans);
    check(ouf);

    quitf(_ok, "all checks passed");

}