#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), step = opt<int>("step");

    int k = sqrt(n);
    vector<int> xspaces(k - 1);
    for (int &s : xspaces) s = rnd.next(1, step);
    auto yspaces = xspaces;
    if (rnd.next() < 0.5) reverse(yspaces.begin(), yspaces.end());

    vector<int> xs{rnd.next(1, step * n)}, ys{rnd.next(1, step * n)};
    for (int i = 1; i < k; i++) {
        xs.push_back(xs.back() + xspaces[i - 1]);
        ys.push_back(ys.back() + yspaces[i - 1]);
    }

    vector<pair<int, int>> pts;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            pts.emplace_back(xs[i], ys[j]);
        }
    }
    while (pts.size() < n) {
        pts.emplace_back(rnd.next(1, step * n), rnd.next(1, step * n));
    }
    shuffle(pts.begin(), pts.end());

    println(n);
    for (auto &p : pts) println(p.first, p.second);

}