// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	// ai * bj + aj * bk + ak * bi >= bi * aj + bj * ak + bk * ai
	int n;
	cin >> n;
	vector<ll> a, b;
	for (int i = 0; i < n; ++i) {
		int na, nb;
		cin >> na >> nb;
		a.push_back(na);
		b.push_back(nb);
	}

	auto is_bad = [&](int i, int j, int k) {
		return a[i] * b[j] + a[j] * b[k] + a[k] * b[i] < b[i] * a[j] + b[j] * a[k] + b[k] * a[i];
	};

	vector<int> perm(n);
	iota(perm.begin(), perm.end(), 0);
	shuffle(perm.begin(), perm.end(), tw);

	int cur_bad_pairs = 0;
	for (int i = 0; i + 3 <= n; ++i) {
		cur_bad_pairs += is_bad(perm[i], perm[i + 1], perm[i + 2]);
	}

	while (cur_bad_pairs > 0) {
		int i = rnd(0, n - 1);
		int j = rnd(0, n - 1);
		vector<int> touch;
		for (int d = 0; d <= 2; ++d) {
			if (0 <= i - d && i - d + 3 <= n) {
				touch.push_back(i - d);
			}
			if (0 <= j - d && j - d + 3 <= n) {
				touch.push_back(j - d);
			}
		}
		sort(touch.begin(), touch.end());
		touch.erase(unique(touch.begin(), touch.end()), touch.end());
		int was = cur_bad_pairs;
		for (int ind : touch) {
			cur_bad_pairs -= is_bad(perm[ind], perm[ind + 1], perm[ind + 2]);
		}

		swap(perm[i], perm[j]);

		for (int ind : touch) {
			cur_bad_pairs += is_bad(perm[ind], perm[ind + 1], perm[ind + 2]);
		}

		if (cur_bad_pairs > was) {
			cur_bad_pairs = was;
			swap(perm[i], perm[j]);
		}
	}

	for (int ind : perm) {
		cout << ind + 1 << " ";
	}
	cout << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}