#include <bits/stdc++.h>

#define long long long int
using namespace std;

// @author: pashka

long get_pos(int xl, int yl, int xr, int yr, int i, int x, int y) {
    xl -= i + 1;
    yl -= i + 1;
    xr += i + 1;
    yr += i + 1;
    if (y == yl) {
        return x - xl;
    } else if (x == xr) {
        return xr - xl + y - yl;
    } else if (y == yr) {
        return xr - xl + yr - yl + xr - x;
    } else {
        return xr - xl + yr - yl + xr - xl + yr - y;
    }
}

pair<long, long> ext_euclidean(long a, long b) {
    if (b == 0) return {1, 0};
    long k = a / b;
    auto [x, y] = ext_euclidean(b, a - k * b);
    return {y, x - k * y};
}

pair<long, long> crt(long n, long a, long m, long b) {
    long g = gcd(n, m);
    long d = a - b;
    if (d % g != 0) return {-1, -1};
    auto [x, y] = ext_euclidean(n, m);
    long nn = n * (m / g);
    __int128_t aa = (a - (__int128_t)x * (d / g) % nn * n) % nn;
    if (aa < 0) aa += nn;
    return {nn, aa};
}

int main() {
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    int xl, yl, xr, yr, xp, yp;
    cin >> xl >> yl >> xr >> yr >> xp >> yp;

    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }

    long res = LLONG_MAX;

    for (int ttt = 0; ttt < 2; ttt++) {

        vector<long> t(n), s(n);
        for (int m = 0; m < (1 << n); m++) {
            for (int i = 0; i < n; i++) {
                t[i] = (xr - xl + yr - yl) * 2 + 8 * (i + 1);
                long a = get_pos(xl, yl, xr, yr, i, x[i], y[i]);
                long b = get_pos(xl, yl, xr, yr, i, xp, (m & (1 << i)) ? yl - i - 1 : yr + i + 1);
                s[i] = (b - a + t[i]) % t[i];
            }
            long lcm = 1;
            long val = 0;
            for (int i = 0; i < n; i++) {
                auto p = crt(lcm, val, t[i], s[i]);
                lcm = p.first;
                val = p.second;
                if (lcm == -1) {
                    break;
                }
            }
            if (lcm != -1) {
                res = min(res, val);
            }
        }

        swap(xl, yl);
        swap(xr, yr);
        swap(xp, yp);
        for (int i = 0; i < n; i++) {
            swap(x[i], y[i]);
        }
        xl = -xl;
        xr = -xr;
        xp = -xp;
        for (int i = 0; i < n; i++) {
            x[i] = -x[i];
        }
        swap(xl, xr);
    }

    if (res != LLONG_MAX) {
        cout << res << "\n";
    } else {
        cout << -1 << "\n";
    }


    return 0;
}