#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int max_n = 200'000;
const int maximum_total_length = 2'000'000;
typedef long long ll;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, max_n, "n");
    ensuref(n % 2 == 0, "n must be even");
    inf.readEoln();

    int m = 0;
    for (int i = 0; i < n; ++i) {
        string s = inf.readToken("[a-z]+", "s_i");
        ensuref(m == 0 || m == s.size(), "strings must have similar lengths");
        m = s.size();
        inf.readEoln();
    }
    inf.readEof();
    ensuref(static_cast<ll>(m) * static_cast<ll>(n) <= maximum_total_length,
            "total strings lengths must be no more than %d", maximum_total_length);
}